/* ARCADEmini assembler (unix)
 * version 1.2 date 2003-09-12
 * part of the ARCADEmini project - http[s]://arcademini.schuermans.info/
 * Copyright (C) 2003 1stein <1stein@schuermans.info>
 * Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
 */

#ifndef INC_get_val
#define INC_get_val

#include "id_list.h"
#include "node.h"

//try to get value of node
//retuns 0 on success, 1 on cyclical dependency , -1 on other errors
int get_val_node( st_node * p_node );

//try to get value of identifier
//retuns 0 on success, 1 on cyclical dependency , -1 on other errors
int get_val_ident( st_id_list_entry * p_entry );

//read value of constant node
//returns 0 on success, -1 on error (e.g. when value is unknown yet)
int get_val_read_node_con( st_node * p_node, unsigned long * p_val );

//read number of register node
//returns 0 on success, -1 on error (e.g. when register number is unknown yet)
int get_val_read_node_reg( st_node * p_node, unsigned char * p_reg_no );

//read address from address node
//returns 0 on success, -1 on error (e.g. when address is unknown yet)
int get_val_read_node_addr( st_node * p_node, unsigned long * p_addr_sec, unsigned short * p_addr_ofs );

//read value of constant identifier
//returns 0 on success, -1 on error (e.g. when value is unknown yet)
int get_val_read_ident_con( st_id_list_entry * p_entry, unsigned long * p_val );

//read number of register identifier
//returns 0 on success, -1 on error (e.g. when register number is unknown yet)
int get_val_read_ident_reg( st_id_list_entry * p_entry, unsigned char * p_reg_no );

//read address from address identifier
//returns 0 on success, -1 on error (e.g. when address is unknown yet)
int get_val_read_ident_addr( st_id_list_entry * p_entry, unsigned long * p_addr_sec, unsigned short * p_addr_ofs );

//get value of command parameter
//value is stored in big endian format
//value is stored beginning at bit <first_bit> of buffer (counted from D7 to D0, i.e. D7 of first byte = bit 0)
//*p_bits_written is filled with the number of bits written
//returns 0 on success, -1 on error (e.g. when value is unknown yet)
int get_val_get_cmd_param( st_node * p_cmd, unsigned char param_no, unsigned char * p_buffer, unsigned int buffer_len, unsigned int first_bit, unsigned int * p_bits_written );

#endif //#ifndef INC_get_val

