/* ARCADEmini assembler (unix)
 * version 1.2 date 2003-09-12
 * part of the ARCADEmini project - http[s]://arcademini.schuermans.info/
 * Copyright (C) 2003 1stein <1stein@schuermans.info>
 * Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
 */

#ifndef INC_scan
#define INC_scan

#include <stdio.h>

#include "id_list.h"
#include "node.h"

//current text
extern char * yytext;

int yywrap( );

//initialization function, called by main
void scan_init( FILE * p_input_file );

//an identifier was declared
//remove the last rem_chr characters from identifier name
//put this identifier into the list
//create a node for identifier and return pointer to it
st_node * scan_ident_decl( char * p_name, unsigned int rem_chr, et_id_list_type type );

//an identifier was used
//remove the last rem_chr characters from identifier name
//put this identifier into the list
//create a node for identifier and return pointer to it
st_node * scan_ident_use( char * p_name, unsigned int rem_chr, et_id_list_type type );

//a constant was used
//create a node for constant and return pointer to it
st_node * scan_con( char * p_text );

//a character was used
//create a node for character and return pointer to it
st_node * scan_char( char * p_text );

//a string was scanned
//create a node for string and return pointer to it
st_node * scan_string( char * p_text );

#endif //#ifndef INC_scan
